#ifndef RANDOM_LVL_FUNCTION_H_INCLUDED
#define RANDOM_LVL_FUNCTION_H_INCLUDED
#include <cstdlib>
#include <ctime>
#include <cstdio>
#include <iostream>
#include <windows.h>
#include <cmath>

using namespace std;
struct point
{
    int x;
    int y;
    point (){return;}
    point (int a,int b){x=a;y=b;}
    bool operator==(point &c)
    {
        if(x==c.x&&y==c.y){return true;}
        else return false;
    }
    point operator=(point &c)
    {
        point z;
        z.x=c.x;
        z.y=c.y;
        return z;
    }
};
struct BLOCK
                {bool horizontal;//1 for horizontal and 0 for vertical
                 int length;//in terms of cells
                 int x;//of lower or left end
                 int y;//of lower or left end
                 int occupied_points_x[3];
                 int occupied_points_y[3];
                 //BLOCK operator=(BLOCK &a)
                //{
                 //   BLOCK z;
                 //   z.block_Id=a.block_Id;
                  //  z.horizontal=a.horizontal;
                  //  z.length=a.length;
                   // z.x=a.x;
                   // z.y=a.y;
                   // for(int i=0;i<3;i++)
                   // {
                   //     z.occupied_points[i]=a.occupied_points[i];
                   // }
                  //  return z;
               // }
                 void moveblock(int dist)
                 {
                     if(horizontal){x=x+dist;}
                     if(!horizontal){y=y+dist;}
                     return;
                 }
                 int block_Id;
                 void define_block_Id()
                 {
                     block_Id=(2^x)+(5^y);
                     if(horizontal)
                     {
                         for(int i=x;i<length+x;i++)
                         {
                             occupied_points_y[i-x]=y;
                             occupied_points_x[i-x]=i;
                         }
                     }
                     if(!(horizontal))
                     {
                         for(int i=y;i<y+length;i++)
                         {
                             occupied_points_y[i]=i;
                             occupied_points_x[i]=x;
                         }
                     }
                     return;
                 }
                };
struct blockers_prisoner
{
    BLOCK blockers[];
    BLOCK prisoner;
    int num_block;
};
struct config
{
    int Id;//this_is_actually used to find minimum number of moves
    bool isblockthere[6][6];//array to represent positions where block is present
    BLOCK blockers[13];//array of all the blocks except prisoner
    BLOCK prisoner;//block prisoner
    int num_block;//total num_of_blocks
    int config_creating_move;//the move which created this config // here move is the move of the block
    int Id_block_moved;//Id of last moved block
};

void clean_block(BLOCK block,bool isblockthere[6][6])//this will erase data related to that block
{
    if(block.horizontal)
    {
        for(int i=block.x;i<block.x+block.length;i++)
        {
            isblockthere[i][block.y]=false;
        }
    }
    if(!(block.horizontal))
    {
        for(int i=block.y;i<block.y+block.length;i++)
        {
            isblockthere[block.x][i]=false;
        }
    }
    return;
}
bool is_block_legal(BLOCK a,BLOCK prisoner)
{
    if(a.horizontal)
    {
        if((a.y)=(prisoner.y)){if(a.x>=prisoner.x+prisoner.length){return 0;}}
    }
    return 1;
}

bool can_block_be_placed(BLOCK block,bool isblockthere[6][6])//function which decides whether there is place for a block or not
{
    bool a=0;
    int i,j,k;
    if(block.horizontal)
    {
        for(i=0;i<6;i++)
        {
            for(j=0;j<=6-block.length;j++)
            {
                if(!(isblockthere[j][i]))
                {
                    for(k=j+1;k<j+block.length;k++){if(isblockthere[k][i]==1){a=0;break;};if(isblockthere[k][i]==0){a=1;};};
                    if(a) {return 1;};
                }
            }
        }
    }
    if(!(block.horizontal))
    {
        for(i=0;i<6;i++)
        {
            for(j=0;j<=6-block.length;j++)
            {
                if(!(isblockthere[i][j]))
                {
                    for(k=j+1;k<j+block.length;k++){if(isblockthere[i][k]){a=0;break;};if(isblockthere[i][k]==0){a=1;};};
                    if(a){return 1;}
                }
            }
        }
    }
    return a;
}
void place_block(BLOCK block,bool (&isblockthere)[6][6])//given details of any block,this function will place that block in the array
{
    int i;//index variable
    if(block.horizontal)//in case block is horizontal
    {
        for(i=block.x;i<block.x+block.length;i++)
        {
            isblockthere[i][block.y]=1;
        }
    }
    if(!(block.horizontal))//in case block is vertical
    {
        for(i=block.y;i<(block.y)+(block.length);i++)
        {
            isblockthere[block.x][i]=1;
        }
    }
    return;
}
bool does_the_block_overlap(BLOCK block,bool (&isblockthere)[6][6])//for checking whether we are placing two blocks one over the other
{
    int i;//index
    bool a=0;
    if(block.horizontal)
    {
        for(i=block.x;i<block.x+block.length;i++)
        {
            if(isblockthere[i][block.y]){a=1;break;}
        }
    }
    else if(!(block.horizontal))
    {
        for(i=block.y;i<block.y+block.length;i++)
        {
            if(isblockthere[block.x][i]){a=1;break;}
        }
    }
    return a;
}
BLOCK x_y_assign(BLOCK block)
{
    if(block.horizontal)
    {
        srand(time(0));
        block.y=rand()%6;
        if(block.length==2)
        {
            srand(time(0));block.x=rand()%5;
        }
        else if(block.length==3)
        {
            srand(time(0));block.x=rand()%4;
        }
    }
    else if(!(block.horizontal))
    {
        srand(time(0));
        block.x=rand()%6;
        if(block.length==2)
        {
            srand(time(0));block.y=rand()%5;
        }
        if(block.length==3)
        {
            srand(time(0));
            block.y=rand()%4;
        }
    }
    return block;
}
void randomlvl(int difficulty_level)
{
    int k,j;
    for(k=0;k<1;k++)
    {int D=difficulty_level,num_block,num_moves;//difficulty level D, num_of_blocks and num_of_moves
    int i;//index variables
        if(0<D&&D<8)
        {
            srand(time(0));
            num_block=(rand()%3)+3;
        }
    if(7<D&&D<11)
        {
            srand(time(0));
            num_block=(rand()%3)+4;
        }
    if(10<D&&D<15)
        {
            srand(time(0));
            num_block=(rand()%2)+7;
        }
    if(14<D&&D<22)
        {
            srand(time(0));
            num_block=(rand()%2)+7;
        }
    if(21<D&&D<26)
        {
            srand(time(0));
            num_block=(rand()%2)+7;
        }
    if(25<D&&D<51)
        {
            srand(time(0));
            num_block=(rand()%2)+9;
        }
    if(D>50)
        {
            srand(time(0));
            num_block=(rand()%2)+11;
        }

    BLOCK prisoner;//defining prisoner
    prisoner.horizontal=true;
    prisoner.length=2;
    srand(time(0));
    prisoner.x=rand()%4;
    prisoner.y=3;
    prisoner.define_block_Id();
    bool isblockthere[6][6]={false}; //array in terms of co-ordinates to decide where the blocks exist
    //now assigning proper boolians to the locations of the prisoner
    place_block(prisoner,isblockthere);
    BLOCK blockers[13];
    BLOCK tempa;
    //randomly allocating all the blockers
    for(i=0;i<num_block;i++){srand(time(0));Sleep(1234);
                            blockers[i].horizontal=rand()%2;} //alternate arrangement horizontal or vertical
    for(i=0;i<num_block;i++){if(i<(num_block/2)){blockers[i].length=2;}//if not 13 or 12 blocks then first half are of length 2
                                 else{blockers[i].length=3;}
                                 if(num_block>10){if(i<(4)){blockers[i].length=3;}//if 13 or 12 blocks then first 5 are of length 3
                                 else{blockers[i].length=2;}}}
    for(i=0,j=0;i<num_block;i++)
        {
            if(can_block_be_placed(blockers[i],isblockthere))
                {do {tempa=x_y_assign(blockers[i]);
                blockers[i]=tempa;}
                    while(does_the_block_overlap(blockers[i],isblockthere)||(!is_block_legal(blockers[i],prisoner)));
                    place_block(blockers[i],isblockthere);}
            else if(!(can_block_be_placed(blockers[i],isblockthere)))
            {
                j++;i=-1;
                continue;
            }
        }
    for(i=0;i<num_block;i++)
    {
        blockers[i].define_block_Id();
    }

FILE* Diff_lvl_file;
FILE*record_size_file;
FILE*prisoner_file;
int record_size;
record_size=sizeof(blockers);
Diff_lvl_file=fopen("blockers","wb");
if(Diff_lvl_file==NULL){cout<<"failed to create Diff_lvl_file"<<endl; return;}
rewind(Diff_lvl_file);
fwrite(blockers,record_size,1,Diff_lvl_file);
fclose(Diff_lvl_file);
record_size_file=fopen("record_size","wb");
if(record_size_file==NULL){cout<<"failed to create record_size_file"<<endl;return ;}
rewind(record_size_file);
fwrite(&record_size,4,1,record_size_file);
fclose(record_size_file);
prisoner_file=fopen("prisoner","wb");
if(prisoner_file==NULL){cout<<"failed to create prisoner file"<<endl;return;}
int prisoner_size=sizeof(prisoner);
rewind(prisoner_file);
fwrite(&prisoner,prisoner_size,1,prisoner_file);
fclose(prisoner_file);
FILE*prisoner_size_file=fopen("prisoner_size","wb");
if(prisoner_size_file==NULL){cout<<"failed to create prisoner file size"<<endl;return;}
prisoner_size_file=fopen("prisoner_size","wb");
rewind(prisoner_size_file);
fwrite(&prisoner_size,4,1,prisoner_size_file);
fclose(prisoner_size_file);
FILE*num_block_file;
num_block_file=fopen("num_block","wb");
if(num_block_file==NULL){cout<<"failed to create num_block_file"<<endl;return;}
rewind(num_block_file);
fwrite(&num_block,4,1,num_block_file);
fclose(num_block_file);
FILE*block_present;
block_present=fopen("block_present","wb");
if(block_present==NULL){cout<<"failed to create block present file"<<endl;return;}
fwrite(&isblockthere,36,1,block_present);
fclose(block_present);
return;
}
}
#endif // RANDOM_LVL_FUNCTION_H_INCLUDED
